diff --git a/game/core/src/main/java/net/minecraft/core/world/chunk/Chunk.java b/game/core/src/main/java/net/minecraft/core/world/chunk/Chunk.java
index 16c7d2869..6a9ce7265 100644
--- a/game/core/src/main/java/net/minecraft/core/world/chunk/Chunk.java
+++ b/game/core/src/main/java/net/minecraft/core/world/chunk/Chunk.java
@@ -502,98 +561,109 @@ public class Chunk
         getSection(index).removeEntity(entity);
     }
 
-    public boolean canBlockSeeTheSky(int x, int y, int z)
-    {
-        return y >= getHeightValue(x, z);
+    public boolean canBlockSeeSky(final @NotNull ChunkTilePos tilePos) {
+        return tilePos.y >= this.getHeightValue(tilePos.x, tilePos.z);
     }
 
-    public TileEntity getTileEntity(int x, int y, int z)
-    {
-        ChunkPosition pos = new ChunkPosition(x, y, z);
-        TileEntity tileEntity = tileEntityMap.get(pos);
-        if(tileEntity == null)
-        {
-            Block<?> block = Blocks.getBlock(getBlockID(x, y, z));
-            if(block == null || !block.isEntityTile)
-            {
+    @Deprecated
+    public final boolean canBlockSeeTheSky(final int x, final int y, final int z) {
+        return this.canBlockSeeSky(new ChunkTilePos(x, y, z));
+    }
+
+    public @Nullable TileEntity getTileEntity(final @NotNull ChunkTilePos tilePos) {
+        @Nullable TileEntity tileEntity = this.tileEntityMap.get(tilePos);
+
+        if (tileEntity == null) {
+            final @Nullable Block<?> block = this.getBlock(tilePos);
+            if (block == null || !block.isEntityTile) {
                 return null;
+            } else {
+                block.onBlockPlacedByWorld(this.world, this.pos.x * CHUNK_SIZE_X + tilePos.x, tilePos.y, this.pos.z * CHUNK_SIZE_Z + tilePos.z);
+                tileEntity = this.tileEntityMap.get(tilePos);
             }
-            block.onBlockPlacedByWorld(world, xPosition * CHUNK_SIZE_X + x, y, zPosition * CHUNK_SIZE_Z + z);
-            tileEntity = tileEntityMap.get(pos);
         }
-        if(tileEntity != null && tileEntity.isInvalid())
-        {
-            tileEntityMap.remove(pos);
+
+        if (tileEntity != null && tileEntity.isInvalid()) {
+            this.tileEntityMap.remove(tilePos);
             return null;
         }
-        else
-        {
-            return tileEntity;
-        }
+
+        return tileEntity;
     }
 
-    public void addTileEntity(TileEntity tileEntity)
-    {
-        int x = tileEntity.x - xPosition * CHUNK_SIZE_X;
-        int y = tileEntity.y;
-        int z = tileEntity.z - zPosition * CHUNK_SIZE_Z;
-        setTileEntity(x, y, z, tileEntity);
-        if(isLoaded)
-        {
-            world.tileEntityList.add(tileEntity);
+    @Deprecated
+    public final @Nullable TileEntity getTileEntity(final int x, final int y, final int z) {
+        return this.getTileEntity(new ChunkTilePos(x, y, z));
+    }
+
+    public void addTileEntity(final @NotNull TileEntity tileEntity) {
+        final @NotNull TilePos tilePos = new TilePos(tileEntity.x, tileEntity.y, tileEntity.z);
+
+        this.setTileEntity(tilePos.toChunkTilePos(), tileEntity);
+        if(this.isLoaded) {
+            this.world.tileEntityList.add(tileEntity);
         }
     }
 
     /**
-     * @return True if the specified block entity was set
+     * @return True if the specified tile entity was set
      */
-    public boolean setTileEntity(int x, int y, int z, TileEntity tileEntity)
-    {
-        ChunkPosition chunkposition = new ChunkPosition(x, y, z);
-        tileEntity.worldObj = world;
-        tileEntity.x = xPosition * CHUNK_SIZE_X + x;
-        tileEntity.y = y;
-        tileEntity.z = zPosition * CHUNK_SIZE_Z + z;
-        Block<?> b = Blocks.blocksList[getBlockID(x, y, z)];
-        if (b == null || !b.isEntityTile)
-        {
-            LOGGER.warn("Attempted to place a tile entity {} at {} {} {} where there was no tile entity block!", tileEntity.getClass(), x, y, z);
+    public boolean setTileEntity(final @NotNull ChunkTilePos tilePos, final @NotNull TileEntity tileEntity) {
+        final @NotNull TilePos worldPos = new TilePos(this.pos, tilePos);
+
+        tileEntity.worldObj = this.world;
+        tileEntity.x = worldPos.x;
+        tileEntity.y = worldPos.y;
+        tileEntity.z = worldPos.z;
+
+        final @Nullable Block<?> block = this.getBlock(tilePos);
+        if (block == null || !block.isEntityTile) {
+            LOGGER.warn("Attempted to place a tile entity {} at {} {} {} where there was no tile entity block!", tileEntity.getClass(), worldPos.x, worldPos.y, worldPos.z);
             Thread.dumpStack();
-        }
-        else
-        {
+        } else {
             tileEntity.validate();
-            TileEntity previous = tileEntityMap.put(chunkposition, tileEntity);
+            final @Nullable TileEntity previous = this.tileEntityMap.put(tilePos, tileEntity);
             if (previous != null) {
                 previous.invalidate();
             }
+
             return true;
         }
+
         return false;
     }
 
-    public void removeTileEntity(int x, int y, int z)
-    {
-        ChunkPosition pos = new ChunkPosition(x, y, z);
-        if(isLoaded)
-        {
-            TileEntity tileEntity = tileEntityMap.remove(pos);
-            if(tileEntity != null)
-            {
+    /**
+     * @return True if the specified tile entity was set
+     */
+    @Deprecated
+    public final boolean setTileEntity(final int x, final int y, final int z, final @NotNull TileEntity tileEntity) {
+        return this.setTileEntity(new ChunkTilePos(x, y, z), tileEntity);
+    }
+
+    public void removeTileEntity(final @NotNull ChunkTilePos tilePos) {
+        if (this.isLoaded) {
+            final @Nullable TileEntity tileEntity = this.tileEntityMap.remove(tilePos);
+            if (tileEntity != null) {
                 tileEntity.invalidate();
             }
         }
     }
 
+    @Deprecated
+    public final void removeTileEntity(final int x, final int y, final int z) {
+        this.removeTileEntity(new ChunkTilePos(x, y, z));
+    }
+
     public void removeTileEntity(TileEntity tileEntity) {
-        if (isLoaded && tileEntity != null && tileEntityMap.containsValue(tileEntity)) {
-            tileEntityMap.remove(new ChunkPosition(tileEntity.x & (Chunk.CHUNK_SIZE_X - 1), tileEntity.y, tileEntity.z & (Chunk.CHUNK_SIZE_Z - 1)));
+        if (this.isLoaded && tileEntity != null && tileEntityMap.containsValue(tileEntity)) {
+            final @NotNull ChunkTilePos tilePos = new ChunkTilePos(tileEntity.x, tileEntity.y, tileEntity.z);
+            this.tileEntityMap.remove(tilePos);
             tileEntity.invalidate();
         }
     }
 
-    public void onLoad()
-    {
+    public void onLoad() {
         isLoaded = true;
         world.addAllBlockEntities(tileEntityMap.values());
 
@@ -612,10 +682,6 @@ public class Chunk
             }
         }
 
-        if (this.xPosition == 0 && this.zPosition == 0) {
-            System.out.println("Loaded 0, 0");
-        }
-
         this.scheduleLoadedUpdates();
     }
 
@@ -623,15 +689,14 @@ public class Chunk
         final @NotNull Int2ObjectMap<NextTickListEntry> oldTickList = this.tickList;
         this.tickList = new Int2ObjectArrayMap<>();
 
-        final int worldX = this.xPosition * CHUNK_SIZE_X;
-        final int worldZ = this.zPosition * CHUNK_SIZE_Z;
+        final @NotNull TilePos worldPos = new TilePos(this.pos, new ChunkTilePos(0, 0, 0));
         for (final @NotNull NextTickListEntry entry : oldTickList.values()) {
-            this.world.scheduleBlockUpdate(worldX + entry.x, entry.y, worldZ + entry.z, entry.blockId, entry.delay, true);
+            final @NotNull TilePos entryPos = new TilePos(entry.x, entry.y, entry.z);
+            this.world.scheduleBlockUpdate(worldPos.add(entryPos), entry.blockId, entry.delay, true);
         }
     }
 
-    public void onUnload()
-    {
+    public void onUnload() {
         isLoaded = false;
         TileEntity tileentity;
         for(Iterator<TileEntity> iterator = tileEntityMap.values().iterator(); iterator.hasNext(); tileentity.invalidate())
@@ -642,10 +707,6 @@ public class Chunk
         for (ChunkSection section : sections) {
             section.onUnload(world);
         }
-
-        if (this.xPosition == 0 && this.zPosition == 0) {
-            System.out.println("Unloaded 0, 0");
-        }
     }
 
     public void setChunkModified()
@@ -774,9 +835,9 @@ public class Chunk
         return startIndex;
     }
 
-    public Random getChunkRandom(long xor)
+    public @NotNull Random getChunkRandom(long xor)
     {
-        return new Random(world.getRandomSeed() + (xPosition * xPosition * 0x4c1906L) + (xPosition * 0x5ac0dbL) + (zPosition * zPosition * 0x4307a7L) + (zPosition * 0x5f24fL) ^ xor);
+        return new Random(world.getRandomSeed() + (this.pos.x * this.pos.x * 0x4c1906L) + (this.pos.x * 0x5ac0dbL) + (this.pos.z * this.pos.z * 0x4307a7L) + (this.pos.z * 0x5f24fL) ^ xor);
     }
 
     public boolean isChunkEmpty()
diff --git a/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkCache.java b/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkCache.java
index 178a006c3..2ab5f7fb7 100644
--- a/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkCache.java
+++ b/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkCache.java
@@ -8,283 +8,228 @@ import net.minecraft.core.enums.LightLayer;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.biome.Biome;
+import net.minecraft.core.world.pos.ChunkPos;
+import net.minecraft.core.world.pos.TilePos;
 import net.minecraft.core.world.season.SeasonManager;
+import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
 public class ChunkCache
     implements WorldSource
 {
-    private final int chunkX;
-    private final int chunkZ;
-    private final Chunk[][] chunkArray;
-    private final World worldObj;
-
-    public ChunkCache(World world, int minX, int minY, int minZ, int maxX, int maxY, int maxZ)
-    {
-        worldObj = world;
-        chunkX = Math.floorDiv(minX, Chunk.CHUNK_SIZE_X);
-        chunkZ = Math.floorDiv(minZ, Chunk.CHUNK_SIZE_Z);
-        int maxChunkX = Math.floorDiv(maxX, Chunk.CHUNK_SIZE_X);
-        int maxChunkZ = Math.floorDiv(maxZ, Chunk.CHUNK_SIZE_Z);
-        chunkArray = new Chunk[(maxChunkX - chunkX) + 1][(maxChunkZ - chunkZ) + 1];
-        for(int x = chunkX; x <= maxChunkX; x++)
-        {
-            for(int z = chunkZ; z <= maxChunkZ; z++)
-            {
-                chunkArray[x - chunkX][z - chunkZ] = world.getChunkFromChunkCoords(x, z);
+    private final @NotNull ChunkPos origin;
+    private final @NotNull Chunk @NotNull [] @NotNull [] chunkArray;
+    private final @NotNull World world;
+
+    public ChunkCache(final @NotNull World world, final @NotNull TilePos min, final @NotNull TilePos max) {
+        this.world = world;
+        this.origin = min.toChunkPos();
+
+        final @NotNull ChunkPos chunkMax = max.toChunkPos();
+        this.chunkArray = new Chunk[(chunkMax.x - this.origin.x) + 1][(chunkMax.z - this.origin.z) + 1];
+        for (int x = this.origin.x; x <= chunkMax.x; x++) {
+            for (int z = this.origin.z; z <= chunkMax.z; z++) {
+                this.chunkArray[x - this.origin.x][z - this.origin.z] = this.world.getChunk(new ChunkPos(x, z));
             }
-
         }
+    }
 
+    @Deprecated
+    public ChunkCache(final @NotNull World world, final int minX, final int minY, final int minZ, final int maxX, final int maxY, final int maxZ) {
+        this(world, new TilePos(minX, minY, minZ), new TilePos(maxX, maxY, maxZ));
     }
 
     @Override
-	public int getBlockId(int x, int y, int z)
-    {
-        if(y < 0)
-        {
-            return 0;
-        }
-        if(y >= worldObj.getHeightBlocks())
-        {
-            return 0;
-        }
-        int l = Math.floorDiv(x, Chunk.CHUNK_SIZE_X) - chunkX;
-        int i1 = Math.floorDiv(z, Chunk.CHUNK_SIZE_Z) - chunkZ;
-        if(l < 0 || l >= chunkArray.length || i1 < 0 || i1 >= chunkArray[l].length)
-        {
+    public int getHeightBlocks() {
+        return this.world.getHeightBlocks();
+    }
+
+    @Override
+    public int getBlockId(final @NotNull TilePos tilePos) {
+        if (tilePos.y < 0 || tilePos.y >= this.getHeightBlocks()) {
             return 0;
         }
-        Chunk chunk = chunkArray[l][i1];
-        if(chunk == null)
-        {
+
+        final @NotNull ChunkPos cachePos = tilePos.toChunkPos().sub(this.origin);
+        if (cachePos.x < 0 || cachePos.x >= this.chunkArray.length || cachePos.z < 0 || cachePos.z >= this.chunkArray[cachePos.x].length) {
             return 0;
-        } else
-        {
-            return chunk.getBlockID(x & (Chunk.CHUNK_SIZE_X - 1), y, z & (Chunk.CHUNK_SIZE_Z - 1));
         }
+
+        final @NotNull Chunk chunk = this.chunkArray[cachePos.x][cachePos.z];
+        return chunk.getBlockID(tilePos.x & (Chunk.CHUNK_SIZE_X - 1), tilePos.y, tilePos.z & (Chunk.CHUNK_SIZE_Z - 1));
     }
 
     @Override
-    public @Nullable Block<?> getBlock(int x, int y, int z) {
-        return Blocks.getBlock(getBlockId(x, y, z));
+    public @Nullable Block<?> getBlock(final @NotNull TilePos tilePos) {
+        return Blocks.getBlock(this.getBlockId(tilePos));
     }
 
     @Override
-	public TileEntity getTileEntity(int x, int y, int z)
-    {
-        int l = Math.floorDiv(x, Chunk.CHUNK_SIZE_X) - chunkX;
-        int i1 = Math.floorDiv(z, Chunk.CHUNK_SIZE_Z) - chunkZ;
-        return chunkArray[l][i1].getTileEntity(x & (Chunk.CHUNK_SIZE_X - 1), y, z & (Chunk.CHUNK_SIZE_Z - 1));
+    public @Nullable TileEntity getTileEntity(final @NotNull TilePos tilePos) {
+        final @NotNull ChunkPos cachePos = tilePos.toChunkPos().sub(this.origin);
+        return this.chunkArray[cachePos.x][cachePos.z].getTileEntity(tilePos.x & (Chunk.CHUNK_SIZE_X - 1), tilePos.y, tilePos.z & (Chunk.CHUNK_SIZE_Z - 1));
     }
 
-    public boolean getBlockLitInteriorSurface(int x, int y, int z)
-    {
-        if(x < World.MIN_BLOCK_X || z < World.MIN_BLOCK_Z || x >= World.MAX_BLOCK_X || z > World.MAX_BLOCK_Z)
-        {
-            return true;
-        }
-        if(y < 0)
-        {
+    public boolean getBlockLitInteriorSurface(final @NotNull TilePos tilePos) {
+        if (!tilePos.inBounds(this)) {
             return true;
-        }
-        if(y >= worldObj.getHeightBlocks())
-        {
-            return true;
-        } else
-        {
-            return Block.getIsLitInteriorSurface(worldObj, x, y, z);
+        } else {
+            return Block.getIsLitInteriorSurface(this.world, tilePos);
         }
     }
 
-	@Override
-	public float getBrightness(int x, int y, int z, int blockLightValue) {
-		int i1 = getLightValue(x, y, z);
-		if(i1 < blockLightValue) {
-			i1 = blockLightValue;
-		}
-		return worldObj.worldType.getBrightnessRamp()[i1];
-	}
-
-	@Override
-	public int getLightmapCoord(int x, int y, int z, int blockLightValue) {
-		int skyLight = worldObj.getSavedLightValue(LightLayer.Sky, x, y, z);
-		int blockLight = Math.max(worldObj.getSavedLightValue(LightLayer.Block, x, y, z), blockLightValue);
-		
-		if(getBlockLitInteriorSurface(x, y, z)) {
-			skyLight = Math.max(skyLight, worldObj.getSavedLightValue(LightLayer.Sky, x, y + 1, z));
-			skyLight = Math.max(skyLight, worldObj.getSavedLightValue(LightLayer.Sky, x, y - 1, z));
-			skyLight = Math.max(skyLight, worldObj.getSavedLightValue(LightLayer.Sky, x + 1, y, z));
-			skyLight = Math.max(skyLight, worldObj.getSavedLightValue(LightLayer.Sky, x - 1, y, z));
-			skyLight = Math.max(skyLight, worldObj.getSavedLightValue(LightLayer.Sky, x, y, z + 1));
-			skyLight = Math.max(skyLight, worldObj.getSavedLightValue(LightLayer.Sky, x, y, z - 1));
-			
-			blockLight = Math.max(blockLight, worldObj.getSavedLightValue(LightLayer.Block, x, y + 1, z));
-			blockLight = Math.max(blockLight, worldObj.getSavedLightValue(LightLayer.Block, x, y - 1, z));
-			blockLight = Math.max(blockLight, worldObj.getSavedLightValue(LightLayer.Block, x + 1, y, z));
-			blockLight = Math.max(blockLight, worldObj.getSavedLightValue(LightLayer.Block, x - 1, y, z));
-			blockLight = Math.max(blockLight, worldObj.getSavedLightValue(LightLayer.Block, x, y, z + 1));
-			blockLight = Math.max(blockLight, worldObj.getSavedLightValue(LightLayer.Block, x, y, z - 1));
-		}
-		
-		return getLightmapCoord(skyLight, blockLight);
-	}
+    @Deprecated
+    public boolean getBlockLitInteriorSurface(final int x, final int y, final int z) {
+        return this.getBlockLitInteriorSurface(new TilePos(x, y, z));
+    }
 
     @Override
-    public int getLightmapCoord(int skylight, int blocklight) {
-        return worldObj.getLightmapCoord(skylight, blocklight);
+    public float getBrightness(final @NotNull TilePos tilePos, final int lightEmission) {
+        final int lightValue = this.getBlockLightValue(tilePos);
+        return this.world.getWorldType().getBrightnessRamp()[Math.max(lightValue, lightEmission)];
     }
 
     @Override
-	public float getLightBrightness(int x, int y, int z)
-    {
-        return worldObj.worldType.getBrightnessRamp()[getLightValue(x, y, z)];
+    public int getLightmapCoord(final @NotNull TilePos tilePos, final int lightEmission) {
+        int skyLight = this.world.getSavedLightValue(LightLayer.Sky, tilePos);
+        int blockLight = Math.max(this.world.getSavedLightValue(LightLayer.Block, tilePos), lightEmission);
+
+        if (this.getBlockLitInteriorSurface(tilePos)) {
+            skyLight = Math.max(skyLight, this.world.getSavedLightValue(LightLayer.Sky, tilePos.up()));
+            skyLight = Math.max(skyLight, this.world.getSavedLightValue(LightLayer.Sky, tilePos.down()));
+            skyLight = Math.max(skyLight, this.world.getSavedLightValue(LightLayer.Sky, tilePos.east()));
+            skyLight = Math.max(skyLight, this.world.getSavedLightValue(LightLayer.Sky, tilePos.west()));
+            skyLight = Math.max(skyLight, this.world.getSavedLightValue(LightLayer.Sky, tilePos.south()));
+            skyLight = Math.max(skyLight, this.world.getSavedLightValue(LightLayer.Sky, tilePos.north()));
+
+            blockLight = Math.max(blockLight, this.world.getSavedLightValue(LightLayer.Block, tilePos.up()));
+            blockLight = Math.max(blockLight, this.world.getSavedLightValue(LightLayer.Block, tilePos.down()));
+            blockLight = Math.max(blockLight, this.world.getSavedLightValue(LightLayer.Block, tilePos.east()));
+            blockLight = Math.max(blockLight, this.world.getSavedLightValue(LightLayer.Block, tilePos.west()));
+            blockLight = Math.max(blockLight, this.world.getSavedLightValue(LightLayer.Block, tilePos.south()));
+            blockLight = Math.max(blockLight, this.world.getSavedLightValue(LightLayer.Block, tilePos.north()));
+        }
+
+        return this.getLightmapCoord(skyLight, blockLight);
     }
 
-    public int getLightValue(int x, int y, int z)
-    {
-        return getLightValueExt(x, y, z, true);
+    @Override
+    public int getLightmapCoord(final int skyLight, final int blockLight) {
+        return this.world.getLightmapCoord(skyLight, blockLight);
     }
 
-    public int getLightValueExt(int x, int y, int z, boolean first)
-    {
-        if(x < World.MIN_BLOCK_X || z < World.MIN_BLOCK_Z || x >= World.MAX_BLOCK_X || z > World.MAX_BLOCK_Z)
-        {
+    @Override
+    public float getLightBrightness(final @NotNull TilePos tilePos) {
+        return this.world.worldType.getBrightnessRamp()[this.getBlockLightValue(tilePos)];
+    }
+
+    public int getBlockLightValue(final @NotNull TilePos tilePos) {
+        return this.getBlockLightValue_do(tilePos, true);
+    }
+
+    @Deprecated
+    public int getLightValue(final int x, final int y, final int z) {
+        return this.getBlockLightValue(new TilePos(x, y, z));
+    }
+
+    @Deprecated
+    private int getBlockLightValue_do(final @NotNull TilePos tilePos, final boolean first) {
+        if (tilePos.x < World.MIN_BLOCK_X || tilePos.z < World.MIN_BLOCK_Z || tilePos.x >= World.MAX_BLOCK_X || tilePos.z > World.MAX_BLOCK_Z) {
             return 15;
         }
-        if(first)
-        {
-            if(getBlockLitInteriorSurface(x, y, z))
+
+        if(first) {
+            if (this.getBlockLitInteriorSurface(tilePos))
             {
-                int k1 = getLightValueExt(x, y + 1, z, false);
-                int i2 = getLightValueExt(x + 1, y, z, false);
-                int j2 = getLightValueExt(x - 1, y, z, false);
-                int k2 = getLightValueExt(x, y, z + 1, false);
-                int l2 = getLightValueExt(x, y, z - 1, false);
-                if(i2 > k1)
-                {
-                    k1 = i2;
-                }
-                if(j2 > k1)
-                {
-                    k1 = j2;
-                }
-                if(k2 > k1)
-                {
-                    k1 = k2;
-                }
-                if(l2 > k1)
-                {
-                    k1 = l2;
-                }
-                return k1;
+                final int lightUp = this.getBlockLightValue_do(tilePos.up(), false);
+                final int lightEast = this.getBlockLightValue_do(tilePos.east(), false);
+                final int lightWest = this.getBlockLightValue_do(tilePos.west(), false);
+                final int lightSouth = this.getBlockLightValue_do(tilePos.south(), false);
+                final int lightNorth = this.getBlockLightValue_do(tilePos.north(), false);
+                return Math.max(lightUp, Math.max(lightEast, Math.max(lightWest, Math.max(lightSouth, lightNorth))));
             }
         }
-        if(y < 0)
-        {
+
+        if (tilePos.y < 0) {
             return 0;
         }
-        if(y >= worldObj.getHeightBlocks())
-        {
-            int i1 = 15 - worldObj.skyDarken;
-            if(i1 < 0)
-            {
-                i1 = 0;
+
+        if (tilePos.y >= this.getHeightBlocks()) {
+            int brightness = 15 - this.world.skyDarken;
+            if(brightness < 0) {
+                brightness = 0;
             }
-            return i1;
-        } else
-        {
-            int j1 = Math.floorDiv(x, Chunk.CHUNK_SIZE_X) - chunkX;
-            int l1 = Math.floorDiv(z, Chunk.CHUNK_SIZE_Z) - chunkZ;
-            return chunkArray[j1][l1].getRawBrightness(x & (Chunk.CHUNK_SIZE_X - 1), y, z & (Chunk.CHUNK_SIZE_Z - 1), worldObj.skyDarken);
+            return brightness;
+        } else {
+            final @NotNull ChunkPos cachePos = tilePos.toChunkPos().sub(this.origin);
+            return this.chunkArray[cachePos.x][cachePos.z].getRawBrightness(tilePos.x & (Chunk.CHUNK_SIZE_X - 1), tilePos.y, tilePos.z & (Chunk.CHUNK_SIZE_Z - 1), this.world.skyDarken);
         }
     }
 
     @Override
-	public int getBlockMetadata(int x, int y, int z)
-    {
-        if(y < 0)
-        {
+    public int getBlockData(final @NotNull TilePos tilePos) {
+        if (tilePos.y < 0 || tilePos.y >= this.getHeightBlocks()) {
             return 0;
-        }
-        if(y >= worldObj.getHeightBlocks())
-        {
-            return 0;
-        }
-        else
-        {
-            int chunkX = Math.floorDiv(x, Chunk.CHUNK_SIZE_X) - this.chunkX;
-            int chunkZ = Math.floorDiv(z, Chunk.CHUNK_SIZE_Z) - this.chunkZ;
-            return chunkArray[chunkX][chunkZ].getBlockMetadata(x & (Chunk.CHUNK_SIZE_X - 1), y, z & (Chunk.CHUNK_SIZE_Z - 1));
+        } else {
+            final @NotNull ChunkPos cachePos = tilePos.toChunkPos().sub(this.origin);
+            return this.chunkArray[cachePos.x][cachePos.z].getBlockMetadata(tilePos.x & (Chunk.CHUNK_SIZE_X - 1), tilePos.y, tilePos.z & (Chunk.CHUNK_SIZE_Z - 1));
         }
     }
 
     @Override
-	public Material getBlockMaterial(int x, int y, int z)
-    {
-        int l = getBlockId(x, y, z);
-        if(l == 0)
-        {
+    public @NotNull Material getBlockMaterial(final @NotNull TilePos tilePos) {
+        final @Nullable Block<?> block = this.getBlock(tilePos);
+        if (block == null) {
             return Material.air;
-        } else
-        {
-            return Blocks.blocksList[l].getMaterial();
+        } else {
+            return block.getMaterial();
         }
     }
 
     @Override
-	public boolean isBlockOpaqueCube(int x, int y, int z)
-    {
-        Block<?> block = Blocks.blocksList[getBlockId(x, y, z)];
-        if(block == null)
-        {
-            return false;
-        } else
-        {
-            return block.isSolidRender();
-        }
+    public boolean isBlockOpaqueCube(final @NotNull TilePos tilePos) {
+        final @Nullable Block<?> block = this.getBlock(tilePos);
+        return block != null && block.isSolidRender();
     }
 
     @Override
-	public boolean isBlockNormalCube(int x, int y, int z)
-    {
-        Block<?> block = Blocks.blocksList[getBlockId(x, y, z)];
-        if(block == null)
-        {
-            return false;
-        } else
-        {
-            return block.getMaterial().blocksMotion() && block.isCubeShaped();
-        }
+    public boolean isBlockNormalCube(final @NotNull TilePos tilePos) {
+        final @Nullable Block<?> block = this.getBlock(tilePos);
+        return block != null && block.getMaterial().isSolidBlocking() && block.renderAsNormalBlockOnCondition(this, tilePos.x, tilePos.y, tilePos.z);
     }
 
     @Override
-    public double getBlockTemperature(int x, int z) {
-        return worldObj.getBlockTemperature(x, z);
+    public double getBlockTemperature(final @NotNull TilePos tilePos) {
+        return this.world.getBlockTemperature(tilePos);
     }
 
     @Override
-    public double getBlockHumidity(int x, int z) {
-        return worldObj.getBlockHumidity(x, z);
+    public double getBlockHumidity(final @NotNull TilePos tilePos) {
+        return this.world.getBlockHumidity(tilePos);
     }
 
     @Override
-    public SeasonManager getSeasonManager() {
-        return worldObj.getSeasonManager();
+    public double getBlockVariety(final @NotNull TilePos tilePos) {
+        return this.world.getBlockVariety(tilePos);
     }
 
     @Override
-    public Biome getBlockBiome(int x, int y, int z) {
-        return worldObj.getBlockBiome(x, y, z);
+    public @NotNull SeasonManager getSeasonManager() {
+        return this.world.getSeasonManager();
     }
 
-	@Override
-	public int getSavedLightValue(LightLayer layer, int x, int y, int z) {
-		return worldObj.getSavedLightValue(layer, x, y, z);
-	}
+    @Override
+    public @NotNull Biome getBlockBiome(final @NotNull TilePos tilePos) {
+        return this.world.getBlockBiome(tilePos);
+    }
+
+    @Override
+    public int getSavedLightValue(final @NotNull LightLayer lightLayer, final @NotNull TilePos tilePos) {
+        return this.world.getSavedLightValue(lightLayer, tilePos);
+    }
 
     @Override
     public boolean isRetro() {
-        return worldObj.isRetro();
+        return this.world.isRetro();
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkLoaderLegacy.java b/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkLoaderLegacy.java
index 1914a817b..139b653f5 100644
--- a/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkLoaderLegacy.java
+++ b/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkLoaderLegacy.java
@@ -104,7 +104,7 @@ public class ChunkLoaderLegacy
                 Chunk chunk = loadChunkIntoWorldFromCompound(world, tag.getCompound("Level"));
                 if(!chunk.isAtLocation(x, z))
                 {
-                    LOGGER.warn("Chunk file at {},{} is in the wrong location; relocating. (Expected {}, {}, got {}, {})", x, z, x, z, chunk.xPosition, chunk.zPosition);
+                    LOGGER.warn("Chunk file at {},{} is in the wrong location; relocating. (Expected {}, {}, got {}, {})", x, z, x, z, chunk.pos.x, chunk.pos.z);
                     tag.putInt("xPos", x);
                     tag.putInt("zPos", z);
                     chunk = loadChunkIntoWorldFromCompound(world, tag.getCompound("Level"));
@@ -125,7 +125,7 @@ public class ChunkLoaderLegacy
         throws IOException
     {
         world.checkSessionLock();
-        File chunkFile = chunkFileForXZ(chunk.xPosition, chunk.zPosition);
+        File chunkFile = chunkFileForXZ(chunk.pos.x, chunk.pos.z);
         if(chunkFile.exists())
         {
             LevelData levelData = world.getLevelData();
@@ -151,7 +151,7 @@ public class ChunkLoaderLegacy
         }
         catch(Exception exception)
         {
-            LOGGER.error("Exception while attempting to save chunk at X:{}, Z:{}", chunk.xPosition, chunk.zPosition, exception);
+            LOGGER.error("Exception while attempting to save chunk at X:{}, Z:{}", chunk.pos.x, chunk.pos.z, exception);
         }
     }
 
@@ -168,8 +168,8 @@ public class ChunkLoaderLegacy
         tag.putInt("Version", Global.CURRENT_CHUNK_VERSION);
 
         // Write tags
-        writer.putXPos(chunk.xPosition);
-        writer.putZPos(chunk.zPosition);
+        writer.putXPos(chunk.pos.x);
+        writer.putZPos(chunk.pos.z);
         writer.putTicksOnUnload(world.getWorldTime());
         writer.putHeightMap(chunk.heightMap);
         writer.putAverageBlockHeight(chunk.averageBlockHeight);
diff --git a/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkLoaderRegion.java b/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkLoaderRegion.java
index 926eeecc7..b79a94178 100644
--- a/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkLoaderRegion.java
+++ b/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkLoaderRegion.java
@@ -53,7 +53,7 @@ public class ChunkLoaderRegion
         Chunk chunk = ChunkLoaderLegacy.loadChunkIntoWorldFromCompound(world, tag.getCompound("Level"));
         if(!chunk.isAtLocation(x, z))
         {
-            LOGGER.warn("Chunk file at {},{} is in the wrong location; relocating. (Expected {}, {}, got {}, {})", x, z, x, z, chunk.xPosition, chunk.zPosition);
+            LOGGER.warn("Chunk file at {},{} is in the wrong location; relocating. (Expected {}, {}, got {}, {})", x, z, x, z, chunk.pos.x, chunk.pos.z);
             final CompoundTag level = tag.getCompound("Level");
             level.putInt("xPos", x);
             level.putInt("zPos", z);
@@ -71,7 +71,7 @@ public class ChunkLoaderRegion
         world.checkSessionLock();
         try
         {
-            DataOutputStream regionStream = RegionFileCache.getChunkOutputStream(worldDir, chunk.xPosition, chunk.zPosition);
+            DataOutputStream regionStream = RegionFileCache.getChunkOutputStream(worldDir, chunk.pos.x, chunk.pos.z);
             CompoundTag levelTag = new CompoundTag();
             CompoundTag chunkDataTag = new CompoundTag();
             levelTag.put("Level", chunkDataTag);
@@ -79,11 +79,11 @@ public class ChunkLoaderRegion
             NbtIo.write(levelTag, regionStream);
             regionStream.close();
             LevelData levelData = world.getLevelData();
-            levelData.setSizeOnDisk(levelData.getSizeOnDisk() + (long)RegionFileCache.getSizeDelta(worldDir, chunk.xPosition, chunk.zPosition));
+            levelData.setSizeOnDisk(levelData.getSizeOnDisk() + (long)RegionFileCache.getSizeDelta(worldDir, chunk.pos.x, chunk.pos.z));
         }
         catch (Exception exception)
         {
-            LOGGER.error("Exception while attempting to save chunk at X:{}, Z:{}", chunk.xPosition, chunk.zPosition, exception);
+            LOGGER.error("Exception while attempting to save chunk at X:{}, Z:{}", chunk.pos.x, chunk.pos.z, exception);
         }
     }
 
